unit nw;
interface

uses
 dos,alogin;
const
 OT_USER=$01;
 SUCCESSFUL=$00;
type
 str48=string[48];
 str47=string[47];
 str64=string[64];
 str100=string[100];
 ObjectInfo=record
  ID:LongInt;
  Typ:word;
  Name:Str48;
  Sec:byte;
  O_Flag:byte;
  P_Flag:byte
 end;
 BinderyObject_T=record
  OID:LongInt;
  OType:word;
  OName:Str47
 end;
 BinderyObjectTable=record
  ConnID:byte;
  maxObjects,
  nObjects:word;
  Obj:array[1..1000] of BinderyObject_T
 end;
 GetBinderyObjectID_T=record
  Len:word;
  ObjID:LongInt
 end;
 ShellBuffer=array[0..1024] of byte;
 TRequestBuffer=ShellBuffer;
 TRequestControl=record
  Len:word;
  Fct:byte;
 end;
 TReplyBuffer=ShellBuffer;
 SendBroadcastMsg_T=record
  Len:word;
  StationNr:byte;
  StationList:array[1..250] of byte
 end;
 ObjectConnections=record
  Len:word;
  case boolean of
  true:(StationNr:byte;Station:array[1..100] of byte);
  false:(StationStr:Str100)
 end;
var
 Call_OK:Boolean;
 cCode:word;
 SendBuffer:TRequestBuffer;
 ReceiveBuffer:TReplyBuffer;
 reg:Registers;
 BOT:^BinderyObjectTable;
 E335_Tmp:GetBinderyObjectID_T absolute ReceiveBuffer;
 E315_Tmp:ObjectConnections    absolute ReceiveBuffer;

procedure GetBinderyObjectID2(OType:word;OName:Str47);
procedure GetBinderyObjectID(var O:ObjectInfo);
procedure VerifyBinderyObjectPassword(O:ObjectInfo;PW_1:Str48);
procedure Call(Fkt1,Fkt2:byte;Lngth:word);
procedure PutObj(var O:ObjectInfo;T:word;N:Str48);
procedure PutObjGetID(var O:ObjectInfo;T:word;N:Str48);
function  HasThisPassword(O:ObjectInfo;PW:string):BOOLEAN;
procedure SendToUser(UserName,Message:Str64);
procedure GetObjectConnectionNumbers2(O:ObjectInfo);
procedure SendBroadcastMessage2(var Stations;Message:string);

implementation

procedure SimpleDos(Fkt:byte);{GenericDOSCall with AH}
begin
 reg.AH:=Fkt;
 dos.MsDos(Reg);
 ccode:=reg.AL;{Completion Code for Error handling}
 Call_OK:=(reg.AL=SUCCESSFUL);
end;

procedure Call_ALAH(AL,AH:byte);{GenericDOSCall with AL+AH}
begin
 reg.AL:=AL;
 SimpleDos(AH)
end;

function  GetPreferredConnectionID:byte;
begin
 Call_ALAH($01,$F0);
 GetPreferredConnectionID:=reg.AL
end;

procedure Call(Fkt1,Fkt2:byte;Lngth:word);
{Initiate Call with Standard-Buffer  DS:SI & ES:DI}
{Lngth is #bytes passed +1 (for FctCallNr)}
var
 Request:record
  Len:word;
  Fct:byte;
 end absolute SendBuffer;
 ReceiveLength:word absolute ReceiveBuffer;
begin
 Request.Len:=Lngth;
 Request.Fct:=Fkt2;
 ReceiveLength:=SizeOf(ReceiveBuffer);
 with reg do begin
  DS:=seg(SendBuffer);
  SI:=ofs(SendBuffer);
  ES:=seg(ReceiveBuffer);
  DI:=ofs(ReceiveBuffer)
 end;
 SimpleDos(Fkt1);
end;

procedure ReallyGetBinderyObjectID2(OType:word;OName:Str47);
var
 E335_Req:record
  Ctr:TRequestControl;
  OType:word;
  OName:Str47
 end absolute SendBuffer;
begin
 E335_Req.OType:= Swap(OType);
 E335_Req.OName:= OName;
 Call($E3,$35,4+length(OName));
end;

procedure GetBinderyObjectID2(OType:word;OName:Str47);
var
 i:word;
 Found:Boolean;
begin
 Found:=false;
 if BOT=Nil then ReallyGetBinderyObjectID2(OType,OName) else
 if (BOT^.ConnID<>GetPreferredConnectionID) and (BOT^.ConnID<>$FF)
 then ReallyGetBinderyObjectID2(OType,OName)
 else begin
  for i:=1 to BOT^.nObjects do begin
   if (OType=BOT^.Obj[i].OType) and (OName=BOT^.Obj[i].OName) then begin
    E335_Tmp.ObjID:=BOT^.Obj[i].OID;
    Found:=true;
    Call_OK:=true;
    reg.AL:=0;
    Break;
   end;
  end;
  if (not Found) then begin
   ReallyGetBinderyObjectID2(OType,OName);
   if (BOT^.nObjects < BOT^.MaxObjects) and Call_OK then begin
    if BOT^.nObjects=0 then BOT^.ConnID:=GetPreferredConnectionID;
    inc(BOT^.nObjects);
    BOT^.Obj[BOT^.nObjects].OName:=OName;
    BOT^.Obj[BOT^.nObjects].OType:=OType;
    BOT^.Obj[BOT^.nObjects].OID:=E335_Tmp.ObjID;
    end;
   end
  end;
end;

procedure GetBinderyObjectID(var O:ObjectInfo);{Input:Typ,Name Output:ID}
begin
 GetBinderyObjectID2(O.Typ,O.Name);
 O.ID:=E335_Tmp.ObjID;
end;

procedure VerifyBinderyObjectPassword(O:ObjectInfo;PW_1:Str48);
begin
 ccode:=PasVerifyBinderyObjectPassword(O.Name,O.Typ,PW_1);
 call_OK:=(ccode=0);
 reg.AL:=ccode;
{Putword(3,O.Typ);
 PutLStr(5,O.Name);
 PutLStr(6+length(O.Name),PW_1);
 Call($E3,$3F,5+length(O.Name)+length(PW_1));}
end;

procedure PutObj(var O:ObjectInfo;T:word;N:Str48);
begin
 O.Name:=N;
 O.Typ:=T
end;

procedure PutObjGetID(var O:ObjectInfo;T:word;N:Str48);
begin
 O.Name:=N;
 O.Typ:=T;
 GetBinderyObjectID(O)
end;

{$F+}
function HasThisPassword(O:ObjectInfo;PW:string):BOOLEAN;{$F-}{Need O.Name and O.Typ}
begin
 VerifyBinderyObjectPassword(O,PW);
 HasThisPassword:= Call_OK
end;

procedure GetObjectConnectionNumbers2(O:ObjectInfo);{Input:Typ & Name}
var
 E315_Req:record
  Ctr:TRequestControl;
  OType:word;
  OName:Str47
 end absolute SendBuffer;
begin
 E315_Req.OType:= Swap(O.Typ);
 E315_Req.OName:= O.Name;
 Call($E3,$15,4+length(O.Name));
end;

{Move string plus Length-byte to Request-Buffer}
procedure PutLStr(Offset:word;xPut:string);
begin
 MOVE(xPut[0],SendBuffer[Offset],SUCC(ORD(xPut[0])));
end;

{Input:Target stations in stringformat (Len+Liste(StatNr)) von beliebigem TYPE;
 Message max 60 chars;}
procedure SendBroadcastMessage2(var Stations;Message:string);
begin
 PutLStr(3,string(Stations));
 PutLStr(4+length(string(Stations)),Message);
 Call($E1,$00,3+length(string(Stations))+length(Message))
end;

procedure SendToUser(UserName,Message:Str64);
var
 User:ObjectInfo;
begin
 PutObj(User,OT_User,UserName);
 GetObjectConnectionNumbers2(User);
 SendBroadCastMessage2(E315_Tmp.StationStr,Message)
end;

end.